# libriries and global setting ####
library(RMySQL)  
library(stringr)
library(RPostgreSQL)
library(rpostgis)
library(reshape2)
library(tidyverse)
library(readxl)
library(sf)
library(parallel)
library(lubridate)
library(plyr)
library(akc)
library(openxlsx)
library(ggrepel)
library(viridis)
library(ggplot2)
library(ggpubr)
library(knitr)
library(kableExtra)
library(pander)
library(flextable)
library(huxtable)
library(ggalluvial)
library(kohonen)
library(ggraph)
library(tidygraph)
library(igraph)
library(influenceR)
library(CINNA)
library(mstknnclust)
library(psych)
library(Matrix)
library(widyr)
library(classInt)
library(rnaturalearth)
library(scales)
library(stringdist)
library(mstknnclust)
library(psych)
library(Matrix)
library(widyr)
library(classInt)
library(rnaturalearth)
library(scales)
library(slam)
library(tm)
library(topicmodels)
library(caret)
library(ldatuning)
library(textcat)
library(stopwords)
library(textmineR)

options("scipen"=100, "digits"=4)

wgs = "+proj=longlat +datum=WGS84 +no_defs +ellps=WGS84 +towgs84=0,0,0"

"%ni%"=Negate('%in%')

st_fun = function(x) (x-min(x, na.rm = T))/(max(x, na.rm = T)-min(x, na.rm = T))

formatting_string <- function(x){
  xx = iconv(x, "UTF-8", 'ASCII//TRANSLIT',sub='x')
  xx = toupper(xx)
  xx = gsub('[^[:alnum:]]',"", xx)
  return(xx)
}
